This is the README file of the Webtrends Optimize® Editing Tools extension.

#### About

The extension allows loading target pages under Optimize Visual Editor without proxy server. It should be added to the browser and enabled.

The extension includes injector script and injector styles to the customer page loaded in iframe. Script and styles are loaded from the extension sources.

#### Directory structure

The default directory structure of a generated browser extension:

```
├── manifest.json
├── README.md
└── src
    ├── background
    │   ├── cors_listener.js
    │   ├── mixed_content_listener.js
    │   ├── optimize_listener.js
    │   ├── tab_manager.js
    │   ├── tag_listener.js
    │   └── xframe_listener.js
    ├── common
    │   └── storage_manager.js
    ├── content
    │   ├── content.js
    │   ├── mixed_content_notifier.js
    │   ├── optimize_injector.js
    │   ├── script_handler.js
    │   ├── scripts_observer.js
    │   └── utils.js
    ├── img
    │   ├── webtrends_avatar.png
    │   ├── webtrends_header.png
    │   └── webtrends_icon.png
    ├── injector
    │   ├── injector_scripts.min.js
    │   └── wt_style.min.css
    └── popup
        ├── popup.css
        ├── popup.html
        ├── popup.js
        └── vendors
            ├── bootstrap.min.css
            └── jquery.min.js
```

*background* - Placeholder for background listener scripts which are loaded as soon as the extension is loaded and stay loaded until the extension is disabled or uninstalled. Used to manage the request done through Visual Editor (block x-frame-options, tag loading etc.).

*content* - Placeholder for content scripts which are loaded into web pages and run in the content of that particular page. It is responsible for loading injector scripts, filtering iframe breaking js codes etc.

*common* - Placeholder for common scripts, such as interacting with browser local storage.

*injector* - Placeholder for injector script and injector styles which will be injected to the customer page.

*manifest.js* - Contains basic metadata about the extension such as its name, version and the permissions it requires. It also provides pointers to other files in the extension.

*popup* - Placeholder for extension popup scripts and styles which provides users with an ability to interact with the extension / manage options.

*img* - Placeholder for any images used in extension.
