// Clearing the service workers cached data
// before navigating to page to avoid
// issues related to iframe blocking headers
var seviceWorkers = (function() {

    var clearSeviceWorkers = function() {
        chrome.browsingData.remove({}, {
            "serviceWorkers": true
        }, function() {});
    };

    var contentMessageListener = function(request, sender, sendResponse) {
        if (request.type === 'CleanSeviceWorkers') {
            clearSeviceWorkers();
            return true;
        }
    };

    var start = function() {
        chrome.runtime.onMessage.addListener(contentMessageListener);
    };

    var stop = function() {
        chrome.runtime.onMessage.removeListener(contentMessageListener);
    };

    return {
        start: start,
        stop: stop
    };

})();

optimizeListener.register(seviceWorkers);