var tagListener = (function() {

    var blockTagRequests = function(details) {
        var isCallToTag = false,
            url = details.url;

        const files = [
            'webtrends.min.js',
            'webtrends.load.js',
            'wt_capi.js',
            'wt.js'
        ];

        for (var i = 0, len = files.length; i < len; ++i) {
            if (url.indexOf(files[i]) !== -1 &&
                url.indexOf('?wt_block=false') === -1) {

                isCallToTag = true;
                break;
            }
        }

        if (isCallToTag) {
            return {
                cancel: true
            };
        } else {
            return {
                requestHeaders: details.requestHeaders
            };
        }
    };

    var start = function(tabId) {
        var filter = {
            urls: ['*://*/*'],
            types: ['script', 'xmlhttprequest'],
            tabId: tabId
        };

        chrome.webRequest.onBeforeSendHeaders.addListener(
            blockTagRequests, filter, ['blocking', 'requestHeaders']
        );
    };

    var stop = function() {
        chrome.webRequest.onBeforeSendHeaders.removeListener(blockTagRequests);
    };

    return {
        start: start,
        stop: stop
    };
})();

optimizeListener.register(tagListener);
