// The module is responsible for getting messages 
// from content validating the urls sent in message
// putting the results to message and sending back
var urlChecker = (function() {
    var currentTab;

    var getTitle = function(result) {
        var title,
            titlePattern = /<title>((?:.|[\r\n])*?)<\/title>/i,
            titlePatternSanitize = /(?:\r\n|\r|\n)/g;
        title = result.match(titlePattern);
        title = title && title[1].replace(titlePatternSanitize, '').trim();
        return title || 'New Project';
    };

    var hasTag = function(result) {
        var tagPattern = /<script(.*)src=(.*)wt.js|wt_capi.js(.*)>/g,
            cleanHtml = result.replace(/(\r\n|\n|\r)/gm, '');
        if (cleanHtml.match(tagPattern)) {
            return true;
        }
        return false;
    };

    var checkInputsUrls = function(urls, sendResponse) {
        var data = {},
            counter = 0;
        var check = function(i) {
            var xhr = new XMLHttpRequest();
            xhr.onreadystatechange = function() {
                if (xhr.readyState === 4) {
                    if (xhr.status >= 200 && xhr.status < 400) {
                        urls[i].hasError = false;
                        urls[i].getTitle = getTitle(xhr.responseText);
                        urls[i].hasTag = hasTag(xhr.responseText);
                    } else {
                        urls[i].hasError = true;
                    }
                    ++counter;
                    if (counter === urls.length) {
                        sendResponse(urls);
                    }
                }
            };
            xhr.open('GET', urls[i].url, true);
            xhr.send();
        };

        for (var i = 0, len = urls.length; i < len; ++i) {
            check(i);
        }
    };

    var contentMessageListener = function(request, sender, sendResponse) {
        if (request.type === 'WTUrlChecking') {
            checkInputsUrls(request.urls, sendResponse); 
            storageManager.addTabToAllowFixSameSitList(currentTab, request.allowUpdateCookie);
            return true;
        }
    };

    var start = function(tabId) {
        currentTab = tabId;
        chrome.runtime.onMessage.addListener(contentMessageListener);
    };

    var stop = function() {
        storageManager.addTabToAllowFixSameSitList(currentTab, false);
        chrome.runtime.onMessage.removeListener(contentMessageListener);
    };

    return {
        start: start,
        stop: stop
    };

})();

optimizeListener.register(urlChecker);
