var xFrameListener = (function() {
    const blockHeaders = ['x-frame-options', 'content-security-policy'];

    // This function is removing x-frame and CSP options from response headers
    // to allow all the pages to be loaded under the iframe in WT.
    var xFrameListener = function(details) {
        var headers = details.responseHeaders.filter(function(header) {
            return (blockHeaders.indexOf(header.name.toLowerCase()) === -1);
        });
        return {
            responseHeaders: headers
        };
    };

    var start = function(tabId) {
        var filter = {
            urls: ['*://*/*'],
            types: ['sub_frame'],
            tabId: tabId
        };

        chrome.webRequest.onHeadersReceived.addListener(
            xFrameListener, filter, ['blocking', 'responseHeaders']
        );
    };

    var stop = function() {
        chrome.webRequest.onHeadersReceived.removeListener(xFrameListener);
    };

    return {
        start: start,
        stop: stop
    };
})();

optimizeListener.register(xFrameListener);
