var contentManager = (function() {

     var responseCallback = function(data) {
         if (document.getElementById('nvw-frame')) {
             document.getElementById('nvw-frame').contentWindow.postMessage({
                 type: 'WTUrlChecked',
                 response: data
             }, '*');
         }
         window.postMessage({
             type: 'WTUrlChecked',
             response: data
         }, '*');
     };

     var messageListener = function(event) {
        var data;
        if (event.data) {
            try {
                data = JSON.parse(event.data);
            } catch (e) {
                data = {};
            }
            if (data.type === 'WTExtensionCheck' && data.text === 'ping') {
                window.postMessage({
                    type: 'WTExtensionCheck',
                    text: 'ok'
                }, '*');
                if (document.getElementById('nvw-frame')) {
                    document.getElementById('nvw-frame').contentWindow.postMessage({
                        type: 'WTExtensionCheck',
                        text: 'ok'
                    }, '*');
                }
            }
            if (data.type === 'WTSave') {
                window.postMessage({
                    type: 'WTSave'
                }, '*');
            }
            if (data.type === 'WTCancel') {
                window.postMessage({
                    type: 'WTCancel'
                }, '*');
            }
            if (data.type === 'WTUrlCheck') {
                chrome.runtime.sendMessage({'type': 'WTUrlChecking',
                    'urls': data.urls, 'allowUpdateCookie': data.allowUpdateCookie}, responseCallback);
            }
            if (data.type === 'WTUrlCheck' || data.type === 'CleanSeviceWorkers') {
                chrome.runtime.sendMessage({'type': 'CleanSeviceWorkers'});
            }
        }
    };

    var init = function() {
        if (storageManager.isToolEnabled()) {
            window.addEventListener('message', messageListener, true);
        }
    };

    storageManager.register(init);
})();
