var optimizeInjector = (function() {
    const WT_LOCAL_INJECTOR_SCRIPT_URL = chrome.extension.getURL(
            'src/injector/injector_scripts.min.js');
    const WT_LOCAL_INJECTOR_CSS_URL = chrome.extension.getURL(
            'src/injector/wt_style.min.css');
    var isInjectorScriptLoaded = false;

    var inject = function() {
        utils.getResource(WT_LOCAL_INJECTOR_SCRIPT_URL).then(
           function(result) {
               utils.addElement(result, 'javascript', 'script',
                                'wt_injector_script');
               isInjectorScriptLoaded = true;
        }).catch (function(e) {
            utils.handleError(e);
        });
        utils.getResource(WT_LOCAL_INJECTOR_CSS_URL).then(
            function(result) {
                utils.addElement(result, 'css', 'style', 'wt_injector_styles');
        }).catch (function(e) {
            utils.handleError(e);
        });
    };

    var messageListener = function(event) {
        var data;
        if (event.data) {
            try {
                data = JSON.parse(event.data);
            } catch (e) {
                data = {};
            }
            if (data.type === 'wt_iframe_v1.0' &&
                data.text === 'wt_iframe_is_loaded_successfully') {

                if (!isInjectorScriptLoaded) {
                    inject();
                }
            }
        }
    };

    var init = function() {
        if (storageManager.isToolEnabled() && utils.inIframe()) {
            window.addEventListener('message', messageListener, false);
        }
    };

    storageManager.register(init);
})();
