var utils = utils || (function() {
    var getResource = function(url) {
        return new Promise(function(resolve, reject) {
            var xhr = new XMLHttpRequest();
            xhr.onload = function() {
                if (this.status >= 200 && this.status <= 300) {
                    resolve(this.responseText);
                } else {
                    reject('Error response: ' + this.status);
                }
            };
            xhr.onerror = reject;
            xhr.open('GET', url);
            xhr.send();
        });
    };

    var addElement = function(content, fileType, elementType, elementId) {
        var element = document.createElement(elementType);
        element.setAttribute('type', 'text/' + fileType);
        element.setAttribute('is_wt_updated', 'true');
        if (document.getElementById(elementId) === null) {
            element.setAttribute('id', elementId);
            if (element.styleSheet) {
                element.styleSheet.cssText = content;
            } else {
                element.appendChild(document.createTextNode(content));
            }
            document.getElementsByTagName('head')[0].appendChild(element);
        }
    };

    var handleError = function(e) {
        if (typeof debug === 'object') {
            debug.print(e);
        }
    };

    var inIframe = function() {
        try {
            return window.self !== window.top;
        } catch (e) {
            return true;
        }
    };

    return {
        getResource: getResource,
        addElement: addElement,
        inIframe: inIframe,
        handleError: handleError
    };
})();
