var updateJSProperties = function(value) {

    chrome.storage.local.remove('allow_editing_javascript', function() {});

    chrome.storage.local.set({'allow_editing_javascript': value}, function() {
        //TODO add console.log only for development
    });
}

var updateCookieProperties = function(value) {

    chrome.storage.local.remove('allow_editing_cookie', function() {});

    chrome.storage.local.set({'allow_editing_cookie': value}, function() {
        //TODO add console.log only for development
    });
}

var updateExtProperties = function(value) {

    chrome.storage.local.remove('enable_editing_tools', function() {});

    chrome.storage.local.set({'enable_editing_tools': value}, function() {
        //TODO add console.log only for development
    });
}

var getOptions = function() {

    chrome.storage.local.get('enable_editing_tools', function(result) {
        if (result['enable_editing_tools'] && result['enable_editing_tools'] === 'off') {
            $('#toggle_optimize_editing button').eq(0).toggleClass('locked_inactive locked_active btn-default btn-info');
            $('#toggle_optimize_editing button').eq(1).toggleClass('unlocked_inactive unlocked_active btn-info btn-default');
            $('#toggle_event_editing button').addClass('disabled');
        } else {
            chrome.storage.local.get('allow_editing_javascript', function(result) {
                if (result['allow_editing_javascript'] && result['allow_editing_javascript'] === 'on') {
                    $('#toggle_event_editing button').eq(0).toggleClass('locked_inactive locked_active btn-default btn-info');
                    $('#toggle_event_editing button').eq(1).toggleClass('unlocked_inactive unlocked_active btn-info btn-default');
                }
            });
        }
    });

    chrome.storage.local.get('allow_editing_javascript', function(result) {
        if(result['allow_editing_javascript'] && result['allow_editing_javascript'] === 'on') {
            $('#event_editing_message').removeClass('hide_message');
        } else {
        }
    });

    chrome.storage.local.get('allow_editing_cookie', function(result) {
        if(result['allow_editing_cookie'] && result['allow_editing_cookie'] === 'off') {
            $('#toggle_sime_site button').eq(0).toggleClass('locked_inactive locked_active btn-default btn-info');
            $('#toggle_sime_site button').eq(1).toggleClass('unlocked_inactive unlocked_active btn-info btn-default');
        }
    });
}

document.addEventListener('DOMContentLoaded', function() {
    getOptions();

    $('#toggle_event_editing button').click(function() {
        if (!$(this).hasClass('disabled')) {
            if($(this).hasClass('locked_active') || $(this).hasClass('unlocked_inactive')){
                updateJSProperties('on');
                $('#event_editing_message').removeClass('hide_message');
            }else{
                updateJSProperties('off');
                $('#event_editing_message').addClass('hide_message');
            }
            $('#toggle_event_editing button').eq(0).toggleClass('locked_inactive locked_active btn-default btn-info');
            $('#toggle_event_editing button').eq(1).toggleClass('unlocked_inactive unlocked_active btn-info btn-default');
        }
    });

    $('#toggle_optimize_editing button').click(function() {
        if($(this).hasClass('locked_active') || $(this).hasClass('unlocked_inactive')){
            $('#toggle_event_editing button').removeClass('disabled');
            updateExtProperties('on');
        } else {
            updateExtProperties('off');
            $('#toggle_event_editing button').addClass('disabled');
        }
        $('#toggle_optimize_editing button').eq(0).toggleClass('locked_inactive locked_active btn-default btn-info');
        $('#toggle_optimize_editing button').eq(1).toggleClass('unlocked_inactive unlocked_active btn-info btn-default');
    });


    $('#toggle_sime_site button').click(function() {
        if($(this).hasClass('locked_active') || $(this).hasClass('unlocked_inactive')){
            updateCookieProperties('on');
        } else {
            updateCookieProperties('off');
        }
        $('#toggle_sime_site button').eq(0).toggleClass('locked_inactive locked_active btn-default btn-info');
        $('#toggle_sime_site button').eq(1).toggleClass('unlocked_inactive unlocked_active btn-info btn-default');
    });

});
